 /*
 * file      : win_result.c
 * project   : BaseBuild
 * with      : Gtk-2
 *
 * copyright : (C) 2010 by Claude Bulin
 *
 * BaseBuild - Creation d'une base de programmation en langage C de type GNU avec les autotools
 * GNU General Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * OLD ADRESS:
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * NEW ADRESS:
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */


#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
#endif

#include <gtk/gtk.h>

#include "global.h"
#include "../libbasebuild/libbasebuild.h"
#include "win_result.h"


GtkWidget	*WindResult = NULL;
GtkWidget	*Adr_textview_result = NULL;
gint		 WindResultPos_X = 100;
gint		 WindResultPos_Y = 100;
gint		 WindResultWidth = 500;
gint		 WindResultHeight = -1;
gboolean	 WindResultIsShow = FALSE;




// CLEAR BUFFER
// 
void WindResult_clear_text (void)
{
	GtkTextBuffer *Buf = NULL;
	GtkTextIter    Start;
	GtkTextIter    End;

	Buf = gtk_text_view_get_buffer (GTK_TEXT_VIEW (Adr_textview_result));
	gtk_text_buffer_get_bounds (Buf, &Start, &End);
	gtk_text_buffer_delete (Buf, &Start, &End);
}
// PLACER DU TEXTE DANS LE TEXTVIEW
// 
void WindResult_set_text (gchar *p_text)
{
	GtkTextBuffer *Buf = NULL;
	GtkTextIter    Start;
	GtkTextIter    End;

	Buf = gtk_text_view_get_buffer (GTK_TEXT_VIEW (Adr_textview_result));
	gtk_text_buffer_get_bounds (Buf, &Start, &End);
	gtk_text_buffer_place_cursor (Buf, &End);
	gtk_text_buffer_insert_at_cursor (Buf, p_text, -1);
}
// PLACER DU TEXTE DANS LE TEXTVIEW
// 
void WindResult_set_text_va (gchar *p_text, ...)
{
	va_list		 VaList;
	gchar		*Ptr = NULL;
	GtkAdjustment	*Adj = NULL;
	
	// PRINT_FUNC_LF();
	
	GDK_THREADS_ENTER();
	
	WindResult_set_text (p_text);
	
	va_start (VaList, p_text);
	while (NULL != (Ptr = va_arg (VaList, gchar *))) {
		 WindResult_set_text (Ptr);
	}
	va_end (VaList);
	
	while (gtk_events_pending()) gtk_main_iteration();
	Adj = gtk_scrolled_window_get_vadjustment (GTK_SCROLLED_WINDOW(GLADE_GET_OBJECT("scrolledwindow_result")));	
	gtk_adjustment_set_value (Adj, (Adj->upper - Adj->page_size) + 100.);
	gtk_scrolled_window_set_vadjustment (GTK_SCROLLED_WINDOW(GLADE_GET_OBJECT("scrolledwindow_result")), Adj);
	while (gtk_events_pending()) gtk_main_iteration();
	
	GDK_THREADS_LEAVE();
}
// RECUPERATION POSITION ET TAILLE DE LA FENETRE
// 
void WindResult_get_pos_window (void)
{
	gdk_window_get_root_origin (WindResult->window, &WindResultPos_X, &WindResultPos_Y);
	gdk_window_get_size (WindResult->window, &WindResultWidth, &WindResultHeight);
	WindResultIsShow = FALSE;
	gtk_widget_hide (WindResult);
}
// QUIT WITH destroy_event
// 
gboolean on_window_result_destroy_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	WindResult_get_pos_window ();
	return TRUE;
}
// QUIT WITH delete_event
// 
gboolean on_window_result_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	WindResult_get_pos_window ();
	return TRUE;
}
// QUIT WITH button
// 
void on_button_quit_result_clicked (GtkButton *button, gpointer user_data)
{
	WindResult_get_pos_window ();
}
// CREATION DE LA FENETRE
// 
void WinResult_open (void)
{
	if (TRUE == WindResultIsShow) {
		gdk_window_raise (WindResult->window);
	}
	else {		
		if (NULL == WindResult) {
			WindResult = GTK_WIDGET (GLADE_GET_OBJECT("window_result"));
			gtk_builder_connect_signals (GtkBuilderXcfa, NULL);
			gtk_window_set_title (GTK_WINDOW (WindResult), "window_result");
		}
		
		if (-1 == WindResultHeight) {
			int dummy;
			GdkWindow *g = gdk_window_get_parent (WindMain->window);
			gdk_window_get_size (g, &dummy, &WindResultHeight);
			WindResultPos_Y = 0;
			WindResultHeight /= 2;
		}
		gtk_window_resize(GTK_WINDOW(WindResult), WindResultWidth, WindResultHeight);
		gtk_window_move(GTK_WINDOW(WindResult), WindResultPos_X, WindResultPos_Y);

		gtk_window_set_transient_for (GTK_WINDOW(WindResult), GTK_WINDOW(WindMain));
		gtk_window_set_modal (GTK_WINDOW (WindResult), TRUE);
		libutils_set_default_icone_to_win (WindResult);

		gtk_widget_show (WindResult);
		
		Adr_textview_result = GTK_WIDGET (GLADE_GET_OBJECT("textview_result"));
	}
	WindResultIsShow = TRUE;
}
















